import App
import MissionLib
import Bridge.BridgeUtils
import Lib.Ambiguity
import QuickBattle.QuickBattle


pBridge = App.g_kSetManager.GetSet('bridge')
BridgeType = App.BridgeSet_Cast(pBridge).GetConfig()
g_pBrex = App.CharacterClass_GetObject(pBridge, 'Engineer')
pBrexMenu = Bridge.BridgeUtils.GetBridgeMenu('Engineer')
BREX_IS_IN = "Bridge1"
BREX_COME_BACK = App.Mission_GetNextEventType()
BREX_GO_DOWN = App.Mission_GetNextEventType()
GOTO_ENGINEERING = App.Mission_GetNextEventType()


# Here is what do to when clicking on that Button	
def GotoEngineering(pObject, pEvent):
	global BREX_IS_IN
	#print(BREX_IS_IN)

	pBridge = App.g_kSetManager.GetSet("bridge")
	g_pBrex	= App.CharacterClass_GetObject(pBridge, "Engineer")
	pShip = App.Game_GetCurrentPlayer()
	
	# Animation, Brex is going
	if ( BREX_IS_IN == "Bridge1" ):
		BREX_IS_IN = "Bridge2"
		#print("Brex is going to Engineering")

		pSeq = MissionLib.NewDialogueSequence()
		pSeq.AppendAction(App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_MOVE, "L1"))
		pSeq.Play()
		
		EngineeringTimer(20.0)

	# OK, Brex has arrived
	elif ( BREX_IS_IN == "Bridge2" ):
		BREX_IS_IN = "Engineering1"
		#print("Brex in his world")
		
		EngineerStartCommand(pShip)
		
		# As long as we can't get Brex back, disable the button:
		#pButton.SetDisabled()
	
	# OK, Brex, stop your work down here and come (Timer) Back
	elif ( BREX_IS_IN == "Engineering1" ):
		BREX_IS_IN = "Engineering2"
		print("Brex is coming back to Bridge")
		
		EngineerStopCommand(pShip)

		EngineeringTimer(5.0)

	# welcome, Brex
	elif ( BREX_IS_IN == "Engineering2" ):
		BREX_IS_IN = "Bridge1"
		print("wb Brex")

		pSeq = MissionLib.NewDialogueSequence()		
		pSeq.AppendAction(App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_MOVE, "E"))
		pSeq.Play()


# we simply Restart
# Get Brex back ASAP when a Brix is unsupported
def Restart():
	global BREX_IS_IN
	#print(BREX_IS_IN)

	if ( BREX_IS_IN == "Engineering1" ):
		import Bridge.XOMenuHandlers
		Bridge.XOMenuHandlers.SetContactEngineeringEnabled(0)
		import Bridge.Characters.SmallAnimations
		
		pBridge = Bridge.BridgeUtils.GetBridge()
		import Bridge.EngineerCharacterHandlers
		if ( BridgeType == "SovereignBridge" ):
			BridgeIS = "Sovereign"
		elif ( BridgeType == "SovereignBridge" ):
			BridgeIS = "Galaxy"
		#print("BridgeIS: " + BridgeIS)
		pEngineering = Bridge.EngineerCharacterHandlers.GetEngineeringSet(BridgeIS)
		pBrex = pEngineering.RemoveObjectFromSet("Engineer")
		pBridge.AddObjectToSet(pBrex, "Engineer")
		
		import Bridge.Characters.Brex
		global g_pBrex
		Bridge.Characters.Brex.ConfigureForSovereign(g_pBrex)

		pBridge = App.g_kSetManager.GetSet("bridge")
		g_pBrex	= App.CharacterClass_GetObject(pBridge, "Engineer")
		pShip = App.Game_GetCurrentPlayer()
		BREX_IS_IN = "Bridge1"
		EngineerStopCommand(pShip)


# Hey Ho, Systems are working better when the Chief is watching
def EngineerStartCommand(pShip):	
	if (pShip.GetShields() != None):
		pShip.GetShields().GetProperty().SetShieldChargePerSecond(App.ShieldClass.FRONT_SHIELDS, pShip.GetShields().GetShieldChargePerSecond(App.ShieldClass.FRONT_SHIELDS) * 1.2)
		pShip.GetShields().GetProperty().SetShieldChargePerSecond(App.ShieldClass.REAR_SHIELDS, pShip.GetShields().GetShieldChargePerSecond(App.ShieldClass.REAR_SHIELDS) * 1.2)
		pShip.GetShields().GetProperty().SetShieldChargePerSecond(App.ShieldClass.TOP_SHIELDS, pShip.GetShields().GetShieldChargePerSecond(App.ShieldClass.TOP_SHIELDS) * 1.2)
		pShip.GetShields().GetProperty().SetShieldChargePerSecond(App.ShieldClass.BOTTOM_SHIELDS, pShip.GetShields().GetShieldChargePerSecond(App.ShieldClass.BOTTOM_SHIELDS) * 1.2)
		pShip.GetShields().GetProperty().SetShieldChargePerSecond(App.ShieldClass.LEFT_SHIELDS, pShip.GetShields().GetShieldChargePerSecond(App.ShieldClass.LEFT_SHIELDS) * 1.2)
		pShip.GetShields().GetProperty().SetShieldChargePerSecond(App.ShieldClass.RIGHT_SHIELDS, pShip.GetShields().GetShieldChargePerSecond(App.ShieldClass.RIGHT_SHIELDS) * 1.2)
	
	if (pShip.GetPowerSubsystem() != None):
		pShip.GetPowerSubsystem().GetProperty().SetPowerOutput(pShip.GetPowerSubsystem().GetPowerOutput() * 1.1)
	
	if (pShip.GetImpulseEngineSubsystem() != None):
		pShip.GetImpulseEngineSubsystem().GetProperty().SetMaxAccel(pShip.GetImpulseEngineSubsystem().GetMaxAccel() * 1.05)
		pShip.GetImpulseEngineSubsystem().GetProperty().SetMaxAngularAccel(pShip.GetImpulseEngineSubsystem().GetMaxAngularAccel() * 1.05)
		pShip.GetImpulseEngineSubsystem().GetProperty().SetMaxAngularVelocity(pShip.GetImpulseEngineSubsystem().GetMaxAngularVelocity() * 1.05)
		pShip.GetImpulseEngineSubsystem().GetProperty().SetMaxSpeed(pShip.GetImpulseEngineSubsystem().GetMaxSpeed() * 1.05)
	
	if (pShip.GetRepairSubsystem() != None):
		pShip.GetRepairSubsystem().GetProperty().SetMaxRepairPoints(pShip.GetRepairSubsystem().GetProperty().GetMaxRepairPoints() * 1.25)


# Bad, Brex is coming Back, Machines back to normal work
def EngineerStopCommand(pShip):
	if (pShip.GetShields() != None):
		pShip.GetShields().GetProperty().SetShieldChargePerSecond(App.ShieldClass.FRONT_SHIELDS, pShip.GetShields().GetShieldChargePerSecond(App.ShieldClass.FRONT_SHIELDS) / 1.2)
		pShip.GetShields().GetProperty().SetShieldChargePerSecond(App.ShieldClass.REAR_SHIELDS, pShip.GetShields().GetShieldChargePerSecond(App.ShieldClass.REAR_SHIELDS) / 1.2)
		pShip.GetShields().GetProperty().SetShieldChargePerSecond(App.ShieldClass.TOP_SHIELDS, pShip.GetShields().GetShieldChargePerSecond(App.ShieldClass.TOP_SHIELDS) / 1.2)
		pShip.GetShields().GetProperty().SetShieldChargePerSecond(App.ShieldClass.BOTTOM_SHIELDS, pShip.GetShields().GetShieldChargePerSecond(App.ShieldClass.BOTTOM_SHIELDS) / 1.2)
		pShip.GetShields().GetProperty().SetShieldChargePerSecond(App.ShieldClass.LEFT_SHIELDS, pShip.GetShields().GetShieldChargePerSecond(App.ShieldClass.LEFT_SHIELDS) / 1.2)
		pShip.GetShields().GetProperty().SetShieldChargePerSecond(App.ShieldClass.RIGHT_SHIELDS, pShip.GetShields().GetShieldChargePerSecond(App.ShieldClass.RIGHT_SHIELDS) / 1.2)
	
	if (pShip.GetPowerSubsystem() != None):
		pShip.GetPowerSubsystem().GetProperty().SetPowerOutput(pShip.GetPowerSubsystem().GetPowerOutput() / 1.1)
	
	if (pShip.GetImpulseEngineSubsystem() != None):
		pShip.GetImpulseEngineSubsystem().GetProperty().SetMaxAccel(pShip.GetImpulseEngineSubsystem().GetMaxAccel() / 1.05)
		pShip.GetImpulseEngineSubsystem().GetProperty().SetMaxAngularAccel(pShip.GetImpulseEngineSubsystem().GetMaxAngularAccel() / 1.05)
		pShip.GetImpulseEngineSubsystem().GetProperty().SetMaxAngularVelocity(pShip.GetImpulseEngineSubsystem().GetMaxAngularVelocity() / 1.05)
		pShip.GetImpulseEngineSubsystem().GetProperty().SetMaxSpeed(pShip.GetImpulseEngineSubsystem().GetMaxSpeed() / 1.05)

	if (pShip.GetRepairSubsystem() != None):
		pShip.GetRepairSubsystem().GetProperty().SetMaxRepairPoints(pShip.GetRepairSubsystem().GetProperty().GetMaxRepairPoints() / 1.25)


def EngineeringTimer(iCountdown):
		# Create an event - it's a thing that will call this function
		pTimerEvent = App.TGEvent_Create()
		pTimerEvent.SetEventType(GOTO_ENGINEERING)
		pTimerEvent.SetDestination(App.TopWindow_GetTopWindow())
					
		# Create a timer - it's a thing that will wait for a given time,then do something
		pTimer = App.TGTimer_Create()
		pTimer.SetTimerStart(App.g_kUtopiaModule.GetGameTime() + iCountdown)
		pTimer.SetDelay(0)
		pTimer.SetDuration(0)
		pTimer.SetEvent(pTimerEvent)
		App.g_kTimerManager.AddTimer(pTimer)


#print(BridgeType)

if ( BridgeType == "SovereignBridge"):
	StockBridge = 1
elif ( BridgeType == "GalaxyBridge" ):
	StockBridge = 1
else:
	StockBridge = 0


if (pBrexMenu != None):
	event = Lib.Ambiguity.getEvent(GOTO_ENGINEERING)
	g_pBrex.AddPythonFuncHandlerForInstance(event, __name__ + ".GotoEngineering")
	pButton = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString('Goto Engineering'), event, 0, g_pBrex)
	pBrexMenu.PrependChild(pButton)
	
	if ( StockBridge == 0 ):
		pButton.SetDisabled()

	StockBridge = 0


App.TopWindow_GetTopWindow().AddPythonFuncHandlerForInstance(GOTO_ENGINEERING, __name__ + ".GotoEngineering")
