# This File is a 1:1 copy from Banbury's QuickBattle Replacement

import App
import MissionLib
import Bridge.BridgeUtils
import Lib.Ambiguity
import QuickBattle.QuickBattle
import Custom.QuickBattleGame.QuickBattle


pBridge = App.g_kSetManager.GetSet('bridge')
g_pBrex = App.CharacterClass_GetObject(pBridge, 'Engineer')
pBrexMenu = Bridge.BridgeUtils.GetBridgeMenu('Engineer')
pGame = App.Game_GetCurrentGame()
pEpisode = pGame.GetCurrentEpisode()
pMission = pEpisode.GetCurrentMission()
pFriendlies = pMission.GetFriendlyGroup()
	

def Transport(pObject, pEvent):
	pPlayer = MissionLib.GetPlayer()
	pTarget = pPlayer.GetTarget()
	pSet = pPlayer.GetContainingSet()
	dist = 300
	pClosest = None
	lpFriendlies = pFriendlies.GetActiveObjectTupleInSet(pSet)
	for pObject in lpFriendlies:
		pFriend = App.ShipClass_Cast(pObject)
		d = Custom.QuickBattleGame.QuickBattle.Distance(pFriend)
		if (d<dist) and (pFriend.GetName() != pPlayer.GetName()) and pFriend.GetImpulseEngineSubsystem() != None:
			pClosest = pFriend
			dist = d
	
	if (pClosest != None):
		MissionLib.RemoveCommandableShip(pClosest.GetName())
		MissionLib.AddCommandableShip(pPlayer.GetName())
		ai = pClosest.GetAI()

		pGame = App.Game_GetCurrentGame()

		pSetPlayerAction = App.TGScriptAction_Create(__name__, "SetPlayerAction", pClosest)
		
		pSequence = App.TGSequence_Create()
		
		pSequence.AppendAction(App.TGScriptAction_Create("Actions.MissionScriptActions", "ChangeToBridge"))
		pSequence.AppendAction(App.TGScriptAction_Create("MissionLib", "StartCutscene"))
		pSequence.AppendAction(App.TGScriptAction_Create("MissionLib", "SetTarget", pClosest.GetName()))
		pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "CutsceneCameraBegin", pSet.GetName()), 2)
		pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "ChangeRenderedSet", pSet.GetName()))
		pSequence.AppendAction(pSetPlayerAction)	
		pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "LockedView", pSet.GetName(), pClosest.GetName(), 30, 30, 15))
		
		pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "CutsceneCameraEnd", pSet.GetName()), 6)	
		pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "ChangeRenderedSet", "bridge"))
		pSequence.AppendAction(App.TGScriptAction_Create("MissionLib", "SetTarget", pPlayer.GetName()))
		pSequence.AppendAction(App.TGScriptAction_Create("MissionLib", "EndCutscene"))

		pSequence.Play()
		MissionLib.SetPlayerAI("Captain", None)
		pPlayer.ClearAI()

	if (pObject):
		pObject.CallNextHandler(pEvent)
	

def SetPlayerAction(pAction, pShip):
	return Custom.QuickBattleGame.QuickBattle.SetPlayerAction(pAction, pShip)


if (pBrexMenu != None):
	event = Lib.Ambiguity.getEvent("ET_TRANSPORT")
	g_pBrex.AddPythonFuncHandlerForInstance(event, __name__ + ".Transport")
	pButton = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString('Transporter'), event, 0, g_pBrex)
	pBrexMenu.PrependChild(pButton)
